<template>
  <v-row>
    <v-col cols="12">
      <v-text-field
        v-model="updateUser.email"
        outlined
        label="Email"
        disabled
        hide-details="auto"
      />
    </v-col>
    <v-col cols="6">
      <v-text-field
        v-model="updateUser.firstName"
        outlined
        label="First Name"
        hide-details="auto"
      />
    </v-col>
    <v-col cols="6">
      <v-text-field
        v-model="updateUser.lastName"
        outlined
        label="Last Name"
        hide-details="auto"
      />
    </v-col>
    <v-col cols="6">
      <v-text-field
        v-model="updateUser.nickName"
        outlined
        label="Nick Name"
        hide-details="auto"
      />
    </v-col>
    <v-col cols="6">
      <v-text-field
        v-model="updateUser.phone"
        outlined
        label="Phone Number"
        type="number"
        hide-details="auto"
      />
    </v-col>
    <v-col cols="6">
      <p v-if="errorMsg">{{errorMsg}}</p>
      <v-btn rounded small color="primary" @click="() => updateAccount()" :loading="loading"
        >Update Account</v-btn
      >
      <v-btn text rounded small color="secondary" class="ml-2" @click="() => setEditAccount()" :loading="loading"
        >Cancel</v-btn
      >
    </v-col>
  </v-row>
</template>

<script>
import { mapState } from 'vuex'

export default {
  name: 'EditAccount',
  props: {
    type: {
      type: String,
      default: 'user'
    },
    setEditAccount: { type: Function }
  },
  data() {
    return {
      updateUser: {},
      errorMsg: null,
      loading: false
    }
  },
  computed: {
    ...mapState('authentication', ['user', 'userUpdated'])
  },
  beforeDestroy() {
    this.$store.dispatch('authentication/setUpdateUser', this.user)
  },
  mounted() {
    this.updateUser = {...this.user}
  },
  created() {
    if (!this.updateUser) this.updateUser = {...this.user}
  },
  methods: {
    updateAccount() {
      if (this.type === 'facilitator') {
        this.$store.dispatch('authentication/updateFacilitator', this.updateUser).then(res => {
          this.setEditAccount(res)
        })
      } else {
        this.$store.dispatch('authentication/updateUser', this.updateUser).then(res => {
          this.setEditAccount(res)
        })
      }
    }
  }
}
</script>
